//package net.wanji.opt.servicev2.implv2;
//
//import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
//import com.fasterxml.jackson.core.type.TypeReference;
//import com.fasterxml.jackson.databind.ObjectMapper;
//import com.github.pagehelper.PageHelper;
//import com.github.pagehelper.PageInfo;
//import lombok.extern.slf4j.Slf4j;
//import net.wanji.common.framework.Constants;
//import net.wanji.common.framework.rest.JsonViewObject;
//import net.wanji.common.utils.tool.DateUtil;
//import net.wanji.common.utils.tool.JacksonUtils;
//import net.wanji.databus.dao.entity.BaseCrossSchemePO;
//import net.wanji.databus.dao.entity.CrossLightsStatusHistPO;
//import net.wanji.databus.dao.entity.GreenwaveCrossPO;
//import net.wanji.databus.dao.entity.GreenwaveHistPO;
//import net.wanji.databus.dao.mapper.BaseCrossSchemeMapper;
//import net.wanji.databus.dao.mapper.CrossDataHistMapper;
//import net.wanji.databus.dao.mapper.GreenwaveCrossMapper;
//import net.wanji.databus.dao.mapper.GreenwaveHistMapper;
//import net.wanji.databus.dto.CrossIdDateTimeDTO;
//import net.wanji.databus.po.CrossDataHistPO;
//import net.wanji.databus.po.CrossSchemeRings;
//import net.wanji.databus.vo.LightsStatusVO2;
//import net.wanji.feign.service.UtcFeignClients;
//import net.wanji.opt.common.RedisUtils;
//import net.wanji.opt.common.enums.EventInfoTypeEnum;
//import net.wanji.opt.common.enums.GreenBeltDirEnum;
//import net.wanji.opt.dao.mapper.*;
//import net.wanji.opt.dto.GreenBeltChartDTO;
//import net.wanji.opt.entity.GreenChartSchemeHist;
//import net.wanji.opt.po.StrategyGreenOptHistEntity;
//import net.wanji.opt.servicev2.TrendServiceV2;
//import net.wanji.opt.synthesis.pojo.StrategyCrossResultEntity;
//import net.wanji.opt.synthesis.pojo.StrategyFactoryEntity;
//import net.wanji.opt.vo.GreenBeltInfoVO;
//import net.wanji.opt.vo2.*;
//import net.wanji.opt.vo2.dto.CrossLastOptResultDTO;
//import net.wanji.opt.vo2.dto.GreenLastOptResultDTO;
//import net.wanji.opt.vo2.dto.GreenOptDTO;
//import org.springframework.beans.BeanUtils;
//import org.springframework.stereotype.Service;
//import org.springframework.util.CollectionUtils;
//import org.springframework.util.StringUtils;
//
//import javax.annotation.Resource;
//import java.time.LocalDateTime;
//import java.util.*;
//import java.util.concurrent.CopyOnWriteArrayList;
//import java.util.stream.Collectors;
//
///**
// * @author duanruiming
// * @date 2025/03/06 18:44
// */
//@Service
//@Slf4j
//public class TrendServiceV2Impl implements TrendServiceV2 {
//
//    @Resource
//    private HoloEventMapper holoEventMapper;
//    @Resource
//    private StrategyCrossResultMapper strategyCrossResultMapper;
//    @Resource
//    private CrossDataHistMapper crossDataHistMapper;
//    @Resource
//    private GreenWaveRealTimeMapperV2Mapper greenWaveRealTimeMapperV2Mapper;
//    @Resource
//    private GreenwaveHistMapper greenwaveHistMapper;
//    @Resource
//    private StrategyGreenOptHistMapper greenOptHistMapper;
//    @Resource
//    private GreenwaveCrossMapper greenwaveCrossMapper;
//    @Resource
//    private StrategyGreenOptHistMapper strategyGreenOptHistMapper;
//    @Resource
//    private RedisUtils redisUtil;
//    @Resource
//    private BaseCrossSchemeMapper baseCrossSchemeMapper;
////    @Resource
////    private BaseCrossInfoCache baseCrossInfoCache;
//    @Resource
//    private UtcFeignClients utcFeignClients;
//    @Resource
//    private StrategyFactoryMapper strategyFactoryMapper;
//    @Resource
//    private GreenChartSchemeHistMapper greenChartSchemeHistMapper;
//
//    private static List<OptMonitoringVO> greenListCache = new CopyOnWriteArrayList<>();
//    private static List<OptMonitoringVO> crossListCache = new CopyOnWriteArrayList<>();
//
//
//    @Override
//    public List<CrossGreenStatusTimeRateVO> crossGreenStatusTimeRate() {
//        List<CrossGreenStatusTimeRateVO> crossGreenStatusTimeRateVOS = holoEventMapper.selectCrossGreenStatusTimeRate();
//        if (!CollectionUtils.isEmpty(crossGreenStatusTimeRateVOS)) {
//            Map<String, CrossGreenStatusTimeRateVO> map = crossGreenStatusTimeRateVOS.stream().collect(Collectors.toMap(CrossGreenStatusTimeRateVO::getType, crossGreenStatusTimeRateVO -> crossGreenStatusTimeRateVO));
//            for (EventInfoTypeEnum typeEnum : EventInfoTypeEnum.values()) {
//                String eventType = typeEnum.getEventType();
//                if (!map.containsKey(eventType)) {
//                    CrossGreenStatusTimeRateVO vo = new CrossGreenStatusTimeRateVO();
//                    vo.setType(eventType);
//                    vo.setCount(0);
//                    crossGreenStatusTimeRateVOS.add(vo);
//                }
//            }
//
//        }
//        return crossGreenStatusTimeRateVOS;
//    }
//
//    @Override
//    public List<CrossOptInfoVO> crossOptInfoList() throws Exception {
//        List<CrossOptInfoVO> results = new ArrayList<>();
//        try {
//            results = new ArrayList<>();
//            List<CrossOptInfoVO> resultList = strategyCrossResultMapper.selectAICrossListV2();
//            long start = DateUtil.getCurrentTimeSecond();
//            long end = start + 5 * 60;
//            LambdaQueryWrapper<CrossDataHistPO> queryWrapper = new LambdaQueryWrapper<>();
//            queryWrapper.between(CrossDataHistPO::getBatchTime, start, end);
//            List<CrossDataHistPO> crossDataHistPOS = crossDataHistMapper.selectList(queryWrapper);
//            if (!CollectionUtils.isEmpty(resultList)) {
//                for (CrossOptInfoVO entity : resultList) {
//                    CrossOptInfoVO result = new CrossOptInfoVO();
//                    String crossId = entity.getCrossId();
//                    Double trafficIndex = entity.getTrafficIndex();
//                    Integer queueLength = entity.getQueueLength();
//                    String location = entity.getLocation();
//                    location = location.replace("POINT(", "").replace(" ", ",").replace(")", "");
//                    BeanUtils.copyProperties(entity, result);
//                    result.setLocation(location);
//                    for (CrossDataHistPO crossDataHistPO : crossDataHistPOS) {
//                        String lastWeekCrossId = crossDataHistPO.getCrossId();
//                        Double lastWeekTrafficIndex = crossDataHistPO.getTrafficIndex();
//                        Double lastWeekQueueLength = crossDataHistPO.getQueueLength();
//                        if (StringUtils.endsWithIgnoreCase(crossId, lastWeekCrossId)) {
//                            if (trafficIndex > lastWeekTrafficIndex) {
//                                result.setTrafficIndexUpDown(1);
//                            } else {
//                                result.setTrafficIndexUpDown(0);
//                            }
//                            if (queueLength > lastWeekQueueLength) {
//                                result.setQueueLengthUpDown(1);
//                            } else {
//                                result.setQueueLengthUpDown(0);
//                            }
//                        }
//                    }
//                    results.add(result);
//                }
//            }
//        } catch (Exception e) {
//            log.error("态势监测-区域体检-雷达图-查询失败:{}", e);
//            throw new Exception(e);
//        }
//        return results;
//    }
//
//    @Override
//    public List<GreenOptInfoVO> greenOptInfoList() throws Exception {
//        List<GreenOptInfoVO> results = new ArrayList<>();
//        List<GreenOptDTO> greenOptDTOS = greenWaveRealTimeMapperV2Mapper.selectGreenOptInfoList();
//        long start = DateUtil.getCurrentTimeSecond();
//        long end = start + 5 * 60;
//        LambdaQueryWrapper<GreenwaveHistPO> queryWrapper = new LambdaQueryWrapper<>();
//        queryWrapper.between(GreenwaveHistPO::getBatchTime, start, end);
//        List<GreenwaveHistPO> greenwaveHistPOS = greenwaveHistMapper.selectList(queryWrapper);
//        if (!CollectionUtils.isEmpty(greenOptDTOS)) {
//            for (GreenOptDTO greenOptDTO : greenOptDTOS) {
//                Integer greenId = greenOptDTO.getGreenId();
//                Double trafficIndex = greenOptDTO.getTrafficIndex();
//                Integer speed = greenOptDTO.getSpeed();
//                Integer travelTime = greenOptDTO.getTravelTime();
//                greenOptDTO.setStrategyName("效率提升");
//                String roadDirection = greenOptDTO.getRoadDirection();
//                greenOptDTO.setDirectionName(GreenBeltDirEnum.getDesc(roadDirection));
//                for (GreenwaveHistPO greenwaveHistPO : greenwaveHistPOS) {
//                    Integer curGreenId = greenwaveHistPO.getGreenId();
//                    String curDirection = greenwaveHistPO.getRoadDirection();
//                    Double curTrafficIndex = greenwaveHistPO.getTrafficIndex();
//                    Double curSpeed = Objects.nonNull(greenwaveHistPO.getSpeed()) ? greenwaveHistPO.getSpeed() : 0;
//                    Integer curTravelTime = greenwaveHistPO.getTrvalTime();
//                    if (Objects.equals(greenId, curGreenId) && StringUtils.endsWithIgnoreCase(roadDirection, curDirection)) {
//
//                        if (trafficIndex > curTrafficIndex) {
//                            greenOptDTO.setTrafficIndexUpDown(1);
//                        } else {
//                            greenOptDTO.setTrafficIndexUpDown(0);
//                        }
//                        if (speed > curSpeed.intValue()) {
//                            greenOptDTO.setSpeedUpDown(1);
//                        } else {
//                            greenOptDTO.setSpeedUpDown(0);
//                        }
//                        if (travelTime > curTravelTime) {
//                            greenOptDTO.setTravelUpDown(1);
//                        } else {
//                            greenOptDTO.setTravelUpDown(0);
//                        }
//                    }
//
//                }
//            }
//            Map<Integer, List<GreenOptDTO>> greenIdMap = greenOptDTOS.stream().collect(Collectors.groupingBy(GreenOptDTO::getGreenId));
//            for (Map.Entry<Integer, List<GreenOptDTO>> entry : greenIdMap.entrySet()) {
//                GreenOptInfoVO greenOptInfoVO = new GreenOptInfoVO();
//                Integer greenId = entry.getKey();
//                List<GreenOptDTO> value = entry.getValue();
//                GreenOptDTO greenOptDTO = value.get(0);
//                greenOptInfoVO.setGreenId(greenId);
//                greenOptInfoVO.setGreenName(greenOptDTO.getGreenName());
//                greenOptInfoVO.setDetails(value);
//                results.add(greenOptInfoVO);
//            }
//        }
//        return results;
//    }
//
//    @Override
//    public List<OptMonitoringVO> greenOptMonitoringList() throws Exception {
//        List<OptMonitoringVO> optMonitoringVOS = holoEventMapper.selectGreenOptMonitoringList();
//        List<GreenLastOptResultDTO> resultDTOS = greenOptHistMapper.selectLastGreenOptResultList();
//        long current = System.currentTimeMillis();
//        optMonitoringVOS.forEach(optMonitoringVO -> {
//            String id = optMonitoringVO.getId();
//            optMonitoringVO.setTypeDesc(EventInfoTypeEnum.getOptDesc(optMonitoringVO.getType()));
//            if (!CollectionUtils.isEmpty(resultDTOS)) {
//                for (GreenLastOptResultDTO resultDTO : resultDTOS) {
//                    Integer greenId = resultDTO.getGreenId();
//                    if (Objects.equals(greenId, Integer.valueOf(id))) {
//                        Integer controlMethod = resultDTO.getControlMethod();
//                        Date optTime = resultDTO.getOptTime();
//                        Integer duration = resultDTO.getDuration();
//                        if (Objects.equals(-1, controlMethod)) {
//                            optMonitoringVO.setOptStatus(0);
//                        } else if (current < optTime.getTime() + duration * 1000) {
//                            optMonitoringVO.setOptStatus(1);
//                            optMonitoringVO.setOptStatusDesc("优化中");
//                        }
//                    }
//                }
//            }
//        });
//        if (!CollectionUtils.isEmpty(greenListCache)) {
//            greenListCache.clear();
//            greenListCache.addAll(optMonitoringVOS);
//        }
//        return optMonitoringVOS;
//    }
//
//    @Override
//    public List<OptMonitoringVO> crossOptMonitoringList() throws Exception {
//        List<OptMonitoringVO> optMonitoringVOS = holoEventMapper.selectCrossOptMonitoringList();
//        List<CrossLastOptResultDTO> optResultDTOS = strategyCrossResultMapper.selectLastOneCrossOptList();
//        long current = System.currentTimeMillis();
//        optMonitoringVOS.forEach(optMonitoringVO -> {
//            String crossId = optMonitoringVO.getId();
//            String evenType = optMonitoringVO.getType();
//            for (CrossLastOptResultDTO optResultDTO : optResultDTOS) {
//                String id = optResultDTO.getId();
//                String type = optMonitoringVO.getType();
//                optMonitoringVO.setTypeDesc(EventInfoTypeEnum.getOptDesc(type));
//                if (StringUtils.endsWithIgnoreCase(id, crossId)) {
//                    Date optTime = optResultDTO.getOptTime();
//                    Integer duration = optResultDTO.getDuration();
//                    // 优化时间计算
//                    optMonitoringVO.setOptTime(optTime);
//                    optMonitoringVO.setOptStatus(0);
//                    if (Objects.nonNull(optTime) && StringUtils.endsWithIgnoreCase(type, evenType) &&
//                            !StringUtils.endsWithIgnoreCase("700", evenType)) {
//                        // 空放优化中，6秒钟结束，当前时间小于开始时间+持续时间
////                        if (StringUtils.endsWithIgnoreCase(EventInfoTypeEnum.PHASE_EMPTY.getEventType(), evenType) && (current - optTime.getTime() <= 6 * 1000)) {
////                            log.error("当前路口空放：{}， 事件类型:{}, 优化类型：{}, ", crossId, evenType, type);
////                            optMonitoringVO.setOptStatus(1);
////                            optMonitoringVO.setOptStatusDesc("优化中");
////                            // 其他事件优化中，当前时间小于优化时间+持续时间
////                        } else if (current - optTime.getTime() <= duration * 1000) {
////                            log.error("当前路口失衡溢出事件：{}， 事件类型:{}, 优化类型：{}, ", crossId, evenType, type);
////                            optMonitoringVO.setOptStatus(1);
////                            optMonitoringVO.setOptStatusDesc("优化中");
////                        }
//                        if(optMonitoringVO.getEventSerialNumber().equals(optResultDTO.getEventId())){
//                            optMonitoringVO.setOptStatus(1);
//                            optMonitoringVO.setOptStatusDesc("优化中");
//                        }
//                    }
//                }
//            }
//        });
//        if (!CollectionUtils.isEmpty(crossListCache)) {
//            crossListCache.clear();
//            crossListCache.addAll(optMonitoringVOS);
//        }
//        return optMonitoringVOS;
//    }
//
//    @Override
//    public List<OptMonitoringVO> eventAlarmRealTimeList() throws Exception {
//        List<OptMonitoringVO> results = new ArrayList<>(90);
//        List<OptMonitoringVO> greenList = new ArrayList<>(10);
//        List<OptMonitoringVO> crossList = new ArrayList<>(80);
//        if (!CollectionUtils.isEmpty(greenListCache)) {
//            greenList = greenListCache;
//        } else {
//            greenList = greenOptMonitoringList();
//        }
//        if (!CollectionUtils.isEmpty(crossListCache)) {
//            crossList = crossListCache;
//        } else {
//            crossList = crossOptMonitoringList();
//        }
//        results.addAll(greenList);
//        results.addAll(crossList);
//        List<OptMonitoringVO> sort = results.stream().sorted(Comparator.comparing(OptMonitoringVO::getStartTime).reversed()).collect(Collectors.toList());
//        return sort;
//    }
//
//    @Override
//    public List<StatisticsEventTypeCountTimeVO> selectGreenEventTypeCountTimeList(EventTypeCountTimeVO vo) throws Exception {
//        String type = vo.getType();
//        LocalDateTime current = vo.getDate();
//        LocalDateTime curDayStart = DateUtil.getLastDayMidNight(current, 0);
//        LocalDateTime latDayStart = DateUtil.getLastDayMidNight(current, -7);
//        LocalDateTime lastDayEnd = current.plusDays(-1);
//        List<StatisticsEventTypeCountTimeVO> currentList = holoEventMapper.selectGreenEventTypeCountTimeList(type, curDayStart, current);
//        List<StatisticsEventTypeCountTimeVO> lastDayList = holoEventMapper.selectGreenEventTypeCountTimeList(type, latDayStart, lastDayEnd);
//        setCountDurationRate(currentList, lastDayList);
//        return currentList;
//    }
//
//    private static void setCountDurationRate(List<StatisticsEventTypeCountTimeVO> currentList, List<StatisticsEventTypeCountTimeVO> lastDayList) {
//        currentList.forEach(result -> {
//            for (StatisticsEventTypeCountTimeVO last : lastDayList) {
//                String id = result.getId();
//                String lastId = last.getId();
//                if (StringUtils.endsWithIgnoreCase(id, lastId)) {
//                    if (last.getCount() == 0 || last.getDuration() == 0) {
//                        continue;
//                    }
//                    double countOffset = (double) result.getCount() - last.getCount();
//                    double durationOffset = (double) result.getDuration() - last.getDuration();
//                    double countRate = countOffset / last.getCount();
//                    double durationRate =  durationOffset / last.getDuration();
//                    result.setCountRate((int) (Math.round(countRate * 100) ));
//                    result.setDurationRate((int) (Math.round(durationRate * 100) ));
//                }
//
//            }
//        });
//    }
//
//    @Override
//    public List<StatisticsEventTypeCountTimeVO> selectCrossEventTypeCountTimeList(EventTypeCountTimeVO vo) throws Exception {
//        String type = vo.getType();
//        LocalDateTime current = vo.getDate();
//        LocalDateTime curDayStart = DateUtil.getLastDayMidNight(current, 0);
//        LocalDateTime latDayStart = DateUtil.getLastDayMidNight(current, -1);
//        LocalDateTime lastDayEnd = current.plusDays(-1);
//        List<StatisticsEventTypeCountTimeVO> currentList = holoEventMapper.selectCrossEventTypeCountTimeList(type, curDayStart, current);
//        List<StatisticsEventTypeCountTimeVO> lastDayList = holoEventMapper.selectCrossEventTypeCountTimeList(type, latDayStart, lastDayEnd);
//        setCountDurationRate(currentList, lastDayList);
//        return currentList;
//    }
//
//    @Override
//    public PageInfo<StatisticsEventTypeCountTimeVO> selectCrossGreenHistList(int pageNo, int pageSize) throws Exception {
//        PageHelper.startPage(pageNo, pageSize);
//        List<StatisticsEventTypeCountTimeVO> results = holoEventMapper.selectCrossGreenHistList();
//        return new PageInfo<>(results);
//    }
//
//    @Override
//    public OptStrategyResultInfoVO optStrategyResultInfo(String id, String dateStr) throws Exception {
//        OptStrategyResultInfoVO result = new OptStrategyResultInfoVO();
//        Date date = new Date();
//        if (!StringUtils.isEmpty(dateStr)) {
//            date = DateUtil.parse(dateStr, Constants.DATE_FORMAT.E_DATE_FORMAT_SECOND);
//        }
//        if (net.wanji.common.utils.tool.StringUtils.isNotBlank(id)) {
//            if (id.length() > 2) {
//                result = getOptCrossResult(id, date);
//            } else {
//                result = getOptGreenResult(id, date);
//            }
//        }
//        return result;
//    }
//
//
//    private OptStrategyResultInfoVO getOptGreenResult(String id, Date date) throws Exception {
//        OptStrategyResultInfoVO optStrategyResultInfoVO = new OptStrategyResultInfoVO();
//
//        LambdaQueryWrapper<StrategyFactoryEntity> strategyQueryWrapper = new LambdaQueryWrapper<>();
//        strategyQueryWrapper.eq(StrategyFactoryEntity::getStatus, 1);
//        strategyQueryWrapper.eq(StrategyFactoryEntity::getType, 2);
//        List<StrategyFactoryEntity> strategyFactoryEntities = strategyFactoryMapper.selectList(strategyQueryWrapper);
//        List<OptStrategyResultInfoVO.Detail> details = new ArrayList<>();
//        for (StrategyFactoryEntity factory : strategyFactoryEntities) {
//            OptStrategyResultInfoVO.Detail detail = new OptStrategyResultInfoVO.Detail();
//            Integer optType = factory.getOptType();
//            String strategyName = factory.getStrategyName();
//            String method = factory.getMethod();
//            String company = factory.getCompany();
//            detail.setOptType(optType);
//            String str = String.join("-", method, strategyName, company);
//            detail.setStrategyName(str);
//            details.add(detail);
//        }
//        optStrategyResultInfoVO.setDetails(details);
//
//        LambdaQueryWrapper<StrategyGreenOptHistEntity> queryWrapper = new LambdaQueryWrapper<>();
//        queryWrapper.eq(StrategyGreenOptHistEntity::getGreenId, id);
//        queryWrapper.le(StrategyGreenOptHistEntity::getControlTime, date);
//        queryWrapper.eq(StrategyGreenOptHistEntity::getControlMethod, 1);
//        queryWrapper.orderByDesc(StrategyGreenOptHistEntity::getControlTime);
//        queryWrapper.last("limit 1");
//        List<StrategyGreenOptHistEntity> entities = strategyGreenOptHistMapper.selectList(queryWrapper);
//        StrategyGreenOptHistEntity entity = entities.get(0);
//        String controlTime = entity.getControlTime();
//        // 如果最新一条在半小时内，取绿波优化数据
//        Date parse = DateUtil.parse(controlTime, Constants.DATE_FORMAT.E_DATE_FORMAT_SECOND);
//        long controlOptTime =  parse.getTime();
//        if (date.getTime() - controlOptTime < 30 * 60 * 1000) {
//            optStrategyResultInfoVO.setCurOptType(4);
//        }
//
//        for (OptStrategyResultInfoVO.Detail detail : details) {
//            Integer optType = detail.getOptType();
//            if (Objects.equals(optType, optStrategyResultInfoVO.getCurOptType())) {
//                optStrategyResultInfoVO.setCurStrategyName(detail.getStrategyName());
//            }
//        }
//
//        return optStrategyResultInfoVO;
//    }
//
//    private OptStrategyResultInfoVO getOptCrossResult(String id, Date date) {
//        OptStrategyResultInfoVO optStrategyResultInfoVO = new OptStrategyResultInfoVO();
//
//        LambdaQueryWrapper<StrategyFactoryEntity> strategyQueryWrapper = new LambdaQueryWrapper<>();
//        strategyQueryWrapper.eq(StrategyFactoryEntity::getStatus, 1);
//        strategyQueryWrapper.eq(StrategyFactoryEntity::getType, 1);
//        List<StrategyFactoryEntity> strategyFactoryEntities = strategyFactoryMapper.selectList(strategyQueryWrapper);
//        List<OptStrategyResultInfoVO.Detail> details = new ArrayList<>();
//        for (StrategyFactoryEntity factory : strategyFactoryEntities) {
//            OptStrategyResultInfoVO.Detail detail = new OptStrategyResultInfoVO.Detail();
//            Integer optType = factory.getOptType();
//            String strategyName = factory.getStrategyName();
//            String method = factory.getMethod();
//            String company = factory.getCompany();
//            detail.setOptType(optType);
//            String str = String.join("-", method, strategyName, company);
//            detail.setStrategyName(str);
//            details.add(detail);
//        }
//        optStrategyResultInfoVO.setDetails(details);
//
//        LambdaQueryWrapper<StrategyCrossResultEntity> queryWrapper = new LambdaQueryWrapper<>();
//        queryWrapper.eq(StrategyCrossResultEntity::getCrossId, id);
//        queryWrapper.le(StrategyCrossResultEntity::getIssueTime, date);
//        queryWrapper.orderByDesc(StrategyCrossResultEntity::getIssueTime);
//        queryWrapper.last("limit 1");
//        List<StrategyCrossResultEntity> results = strategyCrossResultMapper.selectList(queryWrapper);
//        if (!CollectionUtils.isEmpty(results)) {
//            for (StrategyCrossResultEntity result : results) {
//                Integer currentAlgo = result.getCurrentAlgo();
//                Date issueTime = result.getIssueTime();
//                Integer countDown = Math.abs(result.getCountDown());
//                Integer duration = result.getDuration();
//                long optTime = issueTime.getTime();
//                long paramTime = date.getTime();
//                // 空放
//                if (Objects.equals(1, currentAlgo) && paramTime - optTime < countDown * 1000) {
//                    optStrategyResultInfoVO.setCurOptType(1);
//                } else if (paramTime - optTime < duration * 1000) {
//                    optStrategyResultInfoVO.setCurOptType(currentAlgo);
//                }
//            }
//        }
//
//        for (OptStrategyResultInfoVO.Detail detail : details) {
//            Integer optType = detail.getOptType();
//            if (Objects.equals(optType, optStrategyResultInfoVO.getCurOptType())) {
//                optStrategyResultInfoVO.setCurStrategyName(detail.getStrategyName());
//            }
//        }
//        return optStrategyResultInfoVO;
//    }
//
//    @Override
//    public GreenOptCrossOffsetVO optStrategyCrossOffsetList(Integer id, String dateStr) throws Exception {
//        GreenOptCrossOffsetVO greenOptCrossOffsetVO = new GreenOptCrossOffsetVO();
//        Date date = new Date();
//        try {
//            // 如果日期为空，设置为当前日期
//            if (!StringUtils.isEmpty(dateStr)) {
//                date = DateUtil.parse(dateStr, Constants.DATE_FORMAT.E_DATE_FORMAT_SECOND);
//            }
//
//            List<GreenOptCrossOffsetVO.CrossOffsetDetail> oriOffsetDetails = new ArrayList<>();
//            List<GreenOptCrossOffsetVO.CrossOffsetDetail> curOffsetDetails = new ArrayList<>();
//            List<GreenwaveCrossPO> greenwaveCrossPOS = greenwaveCrossMapper.selectByGreenwaveId(id);
//            for (GreenwaveCrossPO greenwaveCrossPO : greenwaveCrossPOS) {
//                String crossId = greenwaveCrossPO.getCrossId();
//                Integer greenId = greenwaveCrossPO.getGreenId();
//
//                String crossName = null;//baseCrossInfoCache.getCrossName(crossId);
//
//                GreenOptCrossOffsetVO.CrossOffsetDetail oriOffsetDetail = getOriOffsetDetail(crossId, date);
//                oriOffsetDetail.setCrossName(crossName);
//                oriOffsetDetails.add(oriOffsetDetail);
//
//                GreenOptCrossOffsetVO.CrossOffsetDetail curOffsetDetail = getCurOffsetDetail(crossId, oriOffsetDetail, date, greenId);
//                curOffsetDetail.setCrossName(crossName);
//                curOffsetDetails.add(curOffsetDetail);
//
//            }
//            greenOptCrossOffsetVO.setOriCrossOffsets(oriOffsetDetails);
//            greenOptCrossOffsetVO.setCurCrossOffsets(curOffsetDetails);
//        } catch (Exception e) {
//            log.error("态势监测-策略推荐-绿波优化相位差查询失败：{}", e);
//            throw new RuntimeException(e);
//        }
//
//        return greenOptCrossOffsetVO;
//    }
//
//    private GreenOptCrossOffsetVO.CrossOffsetDetail getCurOffsetDetail(String crossId, GreenOptCrossOffsetVO.CrossOffsetDetail oriDetail,
//                                                                       Date date, Integer greenId) throws Exception {
//        ObjectMapper mapper = JacksonUtils.getInstance();
//        GreenOptCrossOffsetVO.CrossOffsetDetail curDetail = new GreenOptCrossOffsetVO.CrossOffsetDetail();
//        long currentTime = System.currentTimeMillis();
//        long time = date.getTime();
//        // 最近两分钟内查询缓存实时数据
//        if (currentTime - time < 2 * 60 * 1000) {
//            Object offsetStr = redisUtil.getHash("utc_scheme_offset", crossId);
//            if (Objects.isNull(offsetStr)) {
//                return oriDetail;
//            } else {
//                CrossSchemeRings crossSchemeRings = mapper.readValue(String.valueOf(offsetStr), CrossSchemeRings.class);
//                if (Objects.nonNull(crossSchemeRings)) {
//                    Integer offset = StringUtils.isEmpty(crossSchemeRings.getOffset()) ? 0 : Integer.valueOf(crossSchemeRings.getOffset());
//                    curDetail.setOffset(offset);
//                    curDetail.setCrossId(crossId);
//                    curDetail.setSchemeNo(Integer.valueOf(crossSchemeRings.getPattern()));
//                }
//            }
//        } else { // 历史查询绿波优化记录表
//            LambdaQueryWrapper<StrategyGreenOptHistEntity> queryWrapper = new LambdaQueryWrapper<>();
//            queryWrapper.eq(StrategyGreenOptHistEntity::getGreenId, greenId);
//            queryWrapper.le(StrategyGreenOptHistEntity::getControlTime, date);
//            queryWrapper.eq(StrategyGreenOptHistEntity::getControlMethod, 1);
//            queryWrapper.orderByDesc(StrategyGreenOptHistEntity::getControlTime);
//            queryWrapper.last("limit 1");
//            List<StrategyGreenOptHistEntity> entities = strategyGreenOptHistMapper.selectList(queryWrapper);
//            StrategyGreenOptHistEntity entity = entities.get(0);
//            String controlTime = entity.getControlTime();
//            // 如果最新一条在半小时内，取绿波优化数据
//            Date parse = DateUtil.parse(controlTime, Constants.DATE_FORMAT.E_DATE_FORMAT_SECOND);
//            int controlOptTime = (int) parse.getTime();
//            if (time - controlOptTime < 30 * 60 * 1000) {
//                String crossGreenDetailStr = entity.getCrossGreenDetail();
//                GreenBeltInfoVO.CrossGreenDetail crossGreenDetail = new GreenBeltInfoVO.CrossGreenDetail();
//                List<GreenBeltInfoVO.CrossGreenDetail> greenDetails = mapper.readValue(crossGreenDetailStr, new TypeReference<List<GreenBeltInfoVO.CrossGreenDetail>>() {});
//                for (GreenBeltInfoVO.CrossGreenDetail greenDetail : greenDetails) {
//                    String curCrossId = greenDetail.getCrossId();
//                    Double offset = greenDetail.getOffset();
//                    if (StringUtils.endsWithIgnoreCase(curCrossId, crossId)) {
//                        curDetail.setOffset(offset.intValue());
//                        curDetail.setCrossId(crossId);
//                    }
//                }
//            } else {
//                curDetail = oriDetail;
//            }
//
//        }
//        return curDetail;
//    }
//
//    /**
//     * 从灯态中获取方案号，查询方案表中相位差
//     * @param crossId
//     * @return
//     * @throws Exception
//     */
//    private GreenOptCrossOffsetVO.CrossOffsetDetail getOriOffsetDetail(String crossId, Date date) throws Exception {
//        ObjectMapper mapper = JacksonUtils.getInstance();
//        GreenOptCrossOffsetVO.CrossOffsetDetail crossOffsetDetail = new GreenOptCrossOffsetVO.CrossOffsetDetail();
//        CrossIdDateTimeDTO crossIdDateTimeDTO = new CrossIdDateTimeDTO();
//        crossIdDateTimeDTO.setCrossId(crossId);
//        crossIdDateTimeDTO.setDatetime(date);
//        JsonViewObject jsonViewObject = utcFeignClients.selectLightStatusHist(crossIdDateTimeDTO);
//        if (Objects.nonNull(jsonViewObject.getContent()) && !StringUtils.isEmpty(jsonViewObject.getContent())) {
//            CrossLightsStatusHistPO crossLightsStatusHistPO = mapper.convertValue(jsonViewObject.getContent(), CrossLightsStatusHistPO.class);
//            List<LightsStatusVO2> lightsStatusVO2S = mapper.readValue(crossLightsStatusHistPO.getLightsStatusJson(), new TypeReference<List<LightsStatusVO2>>() {});
//            String schemeId = lightsStatusVO2S.get(0).getSchemeId();
//            Integer schemeNo = Integer.valueOf(schemeId);
//            BaseCrossSchemePO baseCrossSchemePO = baseCrossSchemeMapper.selectByCrossIdAndSchemeNo(crossId, schemeNo);
//            crossOffsetDetail.setOffset(0);
//            if (Objects.nonNull(baseCrossSchemePO)) {
//                Integer offset = baseCrossSchemePO.getOffset();
//                crossOffsetDetail.setCrossId(crossId);
//                crossOffsetDetail.setSchemeNo(schemeNo);
//                crossOffsetDetail.setOffset(offset);
//            }
//        }
//        return crossOffsetDetail;
//    }
//
//    @Override
//    public LightsStatusVO2 selectLightStatusHist(String id, String date) throws Exception {
//        ObjectMapper mapper = JacksonUtils.getInstance();
//        CrossIdDateTimeDTO crossIdDateTimeDTO = new CrossIdDateTimeDTO();
//        crossIdDateTimeDTO.setCrossId(id);
//        crossIdDateTimeDTO.setDatetime(DateUtil.parse(date, Constants.DATE_FORMAT.E_DATE_FORMAT_SECOND));
//        JsonViewObject jsonViewObject = utcFeignClients.selectLightStatusHist(crossIdDateTimeDTO);
//        if (Objects.nonNull(jsonViewObject.getContent()) && !StringUtils.isEmpty(jsonViewObject.getContent())) {
//            CrossLightsStatusHistPO crossLightsStatusHistPO = mapper.convertValue(jsonViewObject.getContent(), CrossLightsStatusHistPO.class);
//            List<LightsStatusVO2> lightsStatusVO2S = mapper.readValue(crossLightsStatusHistPO.getLightsStatusJson(), new TypeReference<List<LightsStatusVO2>>() {});
//            return lightsStatusVO2S.get(0);
//        }
//        return null;
//    }
//
//
//    @Override
//    public GreenBeltChartDTO green4SchemeChart(Integer id, String date) throws Exception {
//        try {
//            GreenBeltChartDTO greenBeltChartDTO = new GreenBeltChartDTO();
//            LambdaQueryWrapper<GreenChartSchemeHist> queryWrapper = new LambdaQueryWrapper<>();
//            queryWrapper.eq(GreenChartSchemeHist::getGreenId, id);
//            queryWrapper.le(GreenChartSchemeHist::getCreateTime, date);
//            queryWrapper.orderByDesc(GreenChartSchemeHist::getCreateTime);
//            queryWrapper.last("limit 1");
//            List<GreenChartSchemeHist> greenChartSchemeHists = greenChartSchemeHistMapper.selectList(queryWrapper);
//            if (!CollectionUtils.isEmpty(greenChartSchemeHists)) {
//                for (GreenChartSchemeHist greenChartSchemeHist : greenChartSchemeHists) {
//                    greenBeltChartDTO = JacksonUtils.getInstance().readValue(greenChartSchemeHist.getGreenChart(), GreenBeltChartDTO.class);
//                }
//            }
//            return greenBeltChartDTO;
//        } catch (Exception e) {
//            log.error("态势监测-绿波时序图查询异常：{}", e);
//            throw new RuntimeException(e);
//        }
//    }
//}